----------------------------------the color library, starting classes, and main window setup variables
color = {
	black = { 0, 0, 0},
	red = { 255, 0, 0},
	green = { 0, 255, 0},
	blue = { 0, 0, 255},
	white = { 255, 255, 255},
	aqua = { 0, 255, 255},
	hotpink = { 255, 0, 255},
	yellow = { 255, 255, 0},
	cream = { 255, 255, 200},
	brickred = { 50, 25, 30},
	brown = { 50, 35, 30},
	purple = { 75, 0, 100},
}
MainWinX = 0
MainWinY = 0
MainWinWidth = 320
MainWinHeight = 240
bwidth = 20
bheight = 20
--Table to hold Dialog class
DialogTbl = {}

dialog = class()

function dialog:init( x, y, text, title)-- could add buttons and other features
	self.x = x
	self.y = y
	self.text = string.format(text)
	self.title = title
	self.width = 200
	self.height = 150
	self.cbw = 10
	self.cbh = 10
	self.cbx = self.x + 175
	self.cby = self.y + 7
	table.insert(DialogTbl, self)
end
function dialog:paint(gc)
	gc:setFont("sansserif", "b", 12)
	gc:setColorRGB(unpack(color.brickred))
	gc:fillRect( self.x, self.y, self.width, self.height)
	gc:setColorRGB(unpack(color.white))
	gc:fillRect( self.x + 5, self.y + 20, self.width - 10, self.height - 30)
	gc:setColorRGB(unpack(color.aqua))
	gc:drawString(self.title, self.x + 10, self.y + 8, "middle")
	gc:drawString(self.text, self.x + 7, self.y + 25, "middle")
	gc:setColorRGB(unpack(color.red))
	gc:fillArc( self.cbx, self.cby, self.cbw, self.cbh, 0, 360)
end
function dialog:click(x, y)
	if (x >= self.cbx and x <= self.cbx + 10) and (y >= self.cby and y <= self.cby + 10) then
		dialogsopen = false
		platform.window:invalidate()
	end
end


function drawDialog(gc)
	if dialogsopen then
		for _, selectedDialog in pairs(DialogTbl) do
		selectedDialog:paint(gc)
		end
	end
end
-------------------------the button code was not made by me it was made by jimbauwens on the omnimaga forum to help someone else but i modified it a little bit
ButtonTable = {}
--Create the class
button = class()

--Create and init the button
function button:init(label, x, y, action)
    self.label = label
    self.x = x
    self.y = y
    self.action = action
    self.labelWidth = 0
    self.width = 0
    self.height = 20

    table.insert(ButtonTable, self)
end

--Draw the button
function button:paint(gc)
	self.labelWidth = gc:getStringWidth(self.label)
	self.width = self.labelWidth + 6
	gc:setColorRGB(150,150,150)
	gc:fillRect(self.x, self.y, self.width, self.height)
	gc:setColorRGB(0, 0, 0)
	gc:setPen("medium", "smooth")
	gc:drawRect(self.x, self.y, self.width, self.height)
	gc:setFont("serif", "b", 12)

	gc:drawString(self.label, self.x + 2, self.y - 1, "top")
end

--What happens if you click the button
function button:click()
	self.action()
end

--Check if clicked, and if clicked call its click method
function button:checkClick(x, y)
	if y >= self.y and y <= self.y + self.height and x >= self.x and x <= self.x + self.width then
		self:click()
	end
end

--Check ButtonTable, and draw all the button in it
function drawButtons(gc)
	for _, selectedButton in pairs(ButtonTable) do
		selectedButton:paint(gc)
	end
end
---------------------------Begining of main program
function on.create()
	dialogsopen = false -- make sure there isnt a dialog open
	DWin1 = dialog(3, 3, "Dialog box is open", "Dia1")
	btn1 = button("A button", 50, 50, OpenDialog)
end
function OpenDialog()
	dialogsopen = true
end
function on.paint(gc)
	platform.gc():setColorRGB( 0, 0, 150)
	platform.gc():fillRect(MainWinX, MainWinY, MainWinWidth, MainWinHeight)
	platform.gc():setColorRGB( 255, 255, 255)
	platform.gc():fillRect( 5, 25, 308, 180)
	platform.gc():setColorRGB(50, 100, 75)
	platform.gc():setFont("sansserif", "b", 12)
	platform.gc():drawString("Walker GUI Shell", 3, 1, "top")
	platform.gc():setColorRGB(200, 0, 0)
	platform.gc():fillRect(292, 2, bwidth, bheight)
	platform.gc():setColorRGB(255, 255, 0)
	platform.gc():fillRect(272, 2, bwidth, bheight)
	platform.gc():setColorRGB(0, 200, 0)
	platform.gc():fillRect(252, 2, bwidth, bheight)
	platform.gc():setFont("sansserif", "b", 12)
	platform.gc():setColorRGB(0, 0, 0)
	platform.gc():drawString("A", 256, 1, "top")
	platform.gc():drawString("?", 276, 1, "top")
	platform.gc():drawString("S", 296, 1, "top")
	drawButtons(gc)
	drawDialog(gc)
end

function on.mouseDown(x, y)
	if dialogsopen == false then
		for _, selectedButton in pairs(ButtonTable) do
			selectedButton:checkClick(x, y)
		end
	end
	if dialogsopen then
		for _, dialogp in pairs(DialogTbl) do
			dialogp:click(x, y)
		end
	end
end
