function on.create()
	setup()
end
function setup()
winset()
varset()
curshown = false
splashscreen = true
winloaded= false
end
function winset()
boxesloaded = false
abouthelp = false
if curshown == true then
else
curshown = false
end
savestate = false
end
function varset()
winset()
winh = 240
winw = 320
bwidth = 20
bheight = 20
aboutx = 50
abouty = 8
arbutonx = 225
arbutony = 15
texty = 60
textx = 60
titlex = 60
titley = 16
color = {
	black = { 0, 0, 0},
	red = { 255, 0, 0},
	green = { 0, 255, 0},
	blue = { 0, 0, 255},
	white = { 255, 255, 255},
	aqua = { 0, 255, 255},
	hotpink = { 255, 0, 255},
	yellow = { 255, 255, 0},
	cream = { 255, 255, 200},
	brickred = { 50, 25, 30},
	brown = { 50, 35, 30},
	purple = { 75, 0, 100},
}
end
-----------------------------cream is hard to see for small quantities
-----------------------------startup of GUI like functions
function on.paint(gc)
	if curshown == false then
	cursor.hide()
	elseif curshown == true then
	cursor.show()
	end
	if splashscreen == true then
	gc:setColorRGB(unpack(color.black))
	gc:fillRect( 0, 0, 320, 240)
	gc:setColorRGB(unpack(color.blue))
	gc:setFont("sansserif", "b", 50)
	gc:drawString("Walker GUI SHELL", 20, 200/2, "middle")
	gc:setFont("sansserif", "r", 10)
	gc:setColorRGB(unpack(color.red))
	gc:drawString("Created by Jonathan Walker" , 10, 150, "bottom")
	gc:setColorRGB(unpack(color.yellow))
	gc:drawString("for use as an example for lua GUI creations.", 10, 170, "bottom")
	timer.start(3)
	end
	if winloaded == true then
	newwin:create()
	gc:setFont("sansserif", "b", 10)
	gc:setColorRGB(unpack(color.brickred))
	gc:drawString("This is an example window, it is made by a class" , 4, 20, "top")
	gc:drawString("a = about", 4, 30, "top")
	gc:drawString("? = help", 4, 40, "top")
	gc:drawString("s = save", 4, 50, "top")
	gc:drawString("show cursor = b", 4, 60, "top")
	gc:drawString("hide cursor = c", 4, 70, "top")
	end
	if (boxesloaded == true) and ((abouthelp == false) and (savestate == false)) then
	aboutbox:make()
	elseif (boxesloaded == true) and (abouthelp == true) then
	aboutbox:createhelp()
	elseif (boxesloaded == true) and (savestate == true) then
	on.save()
	end
end

function on.timer()
	if splashscreen == true then
	splashscreen = false
	winloaded = true
	platform.window:invalidate()
	end
end
function on.escapeKey()
	if (winloaded == true) and (boxesloaded == false) then
	splashscreen = true
	winloaded = false
	platform.window:invalidate()
	elseif (boxesloaded == true) and (winloaded == true) then
	abouthelp = false
	savestate = false
	boxesloaded = false
	varset()
	platform.window:invalidate()
	end
end
newwin = class()
function newwin:create()
	newwin:draw()
	newwin:drawbuttonset()
	newwin:drawtext()
end
function newwin:draw()
	platform.gc():setColorRGB( 0, 0, 150)
	platform.gc():fillRect(0, 0, winw, winh)
	platform.gc():setColorRGB( 255, 255, 255)
	platform.gc():fillRect( 5, 25, 308, 180)
end
function newwin:drawtext()
	platform.gc():setColorRGB(50, 100, 75)
	platform.gc():setFont("sansserif", "b", 12)
	platform.gc():drawString("Walker GUI Shell", 3, 1, "top")
end
function newwin:drawbuttonset()
	platform.gc():setColorRGB(200, 0, 0)
	buttonclose = platform.gc():fillRect(292, 2, bwidth, bheight)
	platform.gc():setColorRGB(255, 255, 0)
	buttonhelp = platform.gc():fillRect(272, 2, bwidth, bheight)
	platform.gc():setColorRGB(0, 200, 0)
	buttonabout = platform.gc():fillRect(252, 2, bwidth, bheight)
	platform.gc():setFont("sansserif", "b", 12)
	platform.gc():setColorRGB(0, 0, 0)
	platform.gc():drawString("A", 256, 1, "top")
	platform.gc():drawString("?", 276, 1, "top")
	platform.gc():drawString("S", 296, 1, "top")
end
function on.charIn(char)
	if char == "a" then
	boxesloaded = true
	elseif char == "s" then
	boxesloaded = true
	savestate = true
	elseif char == "?" then
	boxesloaded = true
	abouthelp = true
	elseif char == "b" then
	curshown = true
	elseif char == "c" then
	curshown = false
	end
	platform.window:invalidate()
end
aboutbox = class()
function aboutbox:make()
	aboutbox:draw()
	aboutbox:drawbuttons()
	aboutbox:drawtext()
end
function aboutbox:draw()
	platform.gc():setColorRGB(unpack(color.brickred))
	platform.gc():fillRect( aboutx, abouty, 200, 150)
	platform.gc():setColorRGB(unpack(color.white))
	platform.gc():fillRect( aboutx + 5, abouty + 20, 190, 120)
end
function aboutbox:drawbuttons()
	platform.gc():setColorRGB( 0, 255, 0)
	platform.gc():fillArc( arbutonx, arbutony, 10, 10, 0, 360)
end
function aboutbox:drawtext()
	platform.gc():setColorRGB(unpack(color.purple))
	platform.gc():drawString("this is an about box.", textx, texty, "middle")
	platform.gc():setColorRGB(unpack(color.cream))
	platform.gc():drawString("About Walker GUI", titlex, titley, "middle")
end
function aboutbox:createhelp()
	aboutbox:draw()
	aboutbox:drawbuttons()
	aboutbox:drawhelptext()
end
function aboutbox:drawhelptext()
	platform.gc():setColorRGB(unpack(color.aqua))
	platform.gc():drawString("this is a help box", textx, texty, "middle")
	platform.gc():setColorRGB(unpack(color.cream))
	platform.gc():drawString("Walker GUI Help", titlex, titley, "middle")
end

function on.save()
	aboutbox:draw()
	aboutbox:drawbuttons()
	platform.gc():setColorRGB(unpack(color.red))
	platform.gc():drawString("you have saved this document", textx - 4, texty, "middle")
	platform.gc():setColorRGB(unpack(color.cream))
	platform.gc():drawString("Walker Saved Box", titlex, titley, "middle")
end
function on.arrowLeft()
	if boxesloaded == true then
	aboutx = aboutx - 1
	arbutonx = arbutonx - 1
	textx = textx - 1
	titlex = titlex - 1
	end
end
function on.arrowRight()
	if boxesloaded == true then
	aboutx = aboutx + 1
	arbutonx = arbutonx + 1
	textx = textx + 1
	titlex = titlex + 1
	end
end
function on.arrowUp()
	if boxesloaded == true then
	abouty = abouty - 1
	arbutony = arbutony - 1
	texty = texty - 1
	titley = titley - 1
	end
end
function on.arrowDown()
	if boxesloaded == true then
	abouty = abouty + 1
	arbutony = arbutony + 1
	texty = texty + 1
	titley = titley + 1
	end
end
-----------function on.mouseDown(mx, my)
-----------was going to do it, but leaving it up to you. the "buttons" are supposed to be accesed by mouse clicks
-----------end
